<?php

/* Language */
$available_lang = array(
	"fr_fr" => "Français",
	"en_us" => "English",
	"es_es" => "Español",
	"pt_br" => "Português brasileiro",
	"ca_es" => "Català",
	"it_it" => "Italiano",
	"nl_nl" => "Dutch",
	"de_de" => "Deutsch",
);
$languages = array(
		   "fr" => "fr_fr", 
		   "it" => "it_it", 
		   "nl" => "nl_nl", 
		   "ca" => "ca_es", 
		   "es" => "es_es", 
		   "pt" => "pt_br", 
		   "en" => "en_us",
		   "de" => "de_de",
		   );

/* As of now, we don't have multiple XX_country languages, so we handle it the quick and dirty way (but efficiently ;) ) */

if (empty($_SESSION["lang"])) {
  $_SESSION["lang"] = strtolower(substr(trim($_SERVER["HTTP_ACCEPT_LANGUAGE"]), 0, 2));
  // Preferred Language of the browser not found => choose default configuration language
  if (!isset($languages[$_SESSION["lang"]])) {
    $_SESSION["lang"] = $doc->config["conf_lang"];
    if (!isset($languages[$_SESSION["lang"]])) { // wrong lang in conf !! choose engrish
      $_SESSION["lang"] = $languages["en"];
    }
  } else {
    $_SESSION["lang"] = $languages[$_SESSION["lang"]];
  }
}


if (!empty($_GET["setlang"]) && isset($available_lang[$_GET["setlang"]]))
  $_SESSION["lang"] = $_GET["setlang"];

if (file_exists("lang/lang_" . $_SESSION["lang"] . ".php"))
	include ("lang/lang_" . $_SESSION["lang"] . ".php");


if (!function_exists("__l"))
{
	function __l($str)
	{
		global $lang_str;
		if (!empty($lang_str[$str]))
			echo $lang_str[$str];
		else
			echo $str;
	}
}

if (!function_exists("_l"))
{
	function _l($str)
	{
		global $lang_str;
		if (!empty($lang_str[$str]))
			return $lang_str[$str];
		else
			return $str;
	}
}


?>