<?php
/* *************************************************
 *
 * Document Manager (C) 2002-2010
 * Version 4 - dmanager MySQL
 * Benjamin Sonntag <benjamin@sonntag.fr>
 * Chantal Bernard-Putz <chantal@bernard-putz.net>
 * Franck Denis
 * This software is protected by copyright laws,
 * please read the file COPYRIGHT
 * This software is provided as is with no warranty.
 *
 ************************************************* */

/* $Id: renamefolder.php 29 2009-11-26 07:02:26Z chantal $ */

require_once ("common.php");

$fields = array (
	"dir"        => array ("request", "integer", 0),
	"folder"     => array ("request", "integer", 0),
	"folderName" => array ("post", "string", ""),
	"action"     => array ("post", "string", ""),
);

getFields($fields);

$infoFolder = $doc->getFolderInfo($folder);
$title = _l("Rename a folder");

if ($action == "dorename" && $folder && $folderName)
{
	if ($doc->hasRight($_SESSION["Sid_user"], "t", $dir))
	{
		if (!$doc->renameFolder($folder, $folderName))
			$error = $doc->errstr();
		else
			$error = _l("Folder successfully renamed !");
	}
	else
		$error = _l("You cannot rename folders !");

	include("browser.php");
	exit();
}

require_once ("head.php");

?>
<p style="display: inline"><br /></p>
<p style="display: inline"><br /></p>
<?php if (!empty($error)) { echo "<p class=\"error\">" . $error . "</p>"; } ?>
<form method="post" action="renamefolder.php">
<div>
<input type="hidden" name="dir" value="<?php echo $dir; ?>" />
<input type="hidden" name="folder" value="<?php echo $folder; ?>" />
<input type="hidden" name="action" value="dorename" />
<table cellpadding="4" cellspacing="0" class="center noborder">
	<tr>
		<th colspan="2"><?php __l("Enter the new name of the folder") ?> <?php echo $infoFolder["folder_name"]; ?></th>
	</tr>
	<tr>
		<th><?php __l("Old Name") ?></th>
		<td><code><?echo $infoFolder["folder_name"]; ?></code></td>
	</tr>
	<tr>
		<th><?php __l("New Name") ?></th>
		<td><input class="int" type="text" name="folderName" size="30" maxlength="128" value="<?php echo $infoFolder["folder_name"]; ?>" /></td>
	</tr>
	<tr>
		<td colspan="2" class="center"><input class="inb" type="submit" value="<?php __l("Rename") ?>" /></td>
	</tr>
</table>
</div>
</form>
<p style="display: inline"><br /></p>
<table style="width: 70%" cellpadding="1" cellspacing="0" class="center">
	<tr>
		<td style="width: 30px">&nbsp;</td>
		<td><img class="vmiddle noborder" src="<?php echo $pngPath; ?>folder.png" alt="Back to the Document Manager" />&nbsp;<a href="browser.php?dir=<?php echo $dir; ?>"><?php __l("Cancel and go back to the Document Manager") ?></a></td>
	</tr>
</table>
<?php require_once ("foot.php"); ?>