<?php
/* *************************************************
 *
 * Document Manager (C) 2002-2010
 * Version 4 - dmanager MySQL
 * Benjamin Sonntag <benjamin@sonntag.fr>
 * Chantal Bernard-Putz <chantal@bernard-putz.net>
 * Franck Denis
 * This software is protected by copyright laws,
 * please read the file COPYRIGHT
 * This software is provided as is with no warranty.
 *
 ************************************************* */
 

/* $Id: search.php,v 1.1.1.1 2005/04/10 01:52:22 benjamin Exp $ */

require_once ("common.php");

$fields = array (
	"dir"            => array ("get", "integer", 0),
	"sort"           => array ("get", "integer", 0),
	"comment"        => array ("get", "integer", 0),
	"action"         => array ("get", "string", ""),
	"pattern"        => array ("get", "string", ""),
	"searchInFolder" => array ("get", "integer", 0),
	"searchInFile"   => array ("get", "integer", 0),
);

getFields($fields);

if (isEmpty($pattern))
{
	header ("Location: browser.php?dir=" . $dir);
	exit;
}

$doc->sort = $sort;

if ($comment == 1)
{
	$_SESSION["Sshow_com"] = 1;
	$doc->updateUserShowComment($_SESSION["Sid_user"], 1);
}

if ($comment == 2)
{
	$_SESSION["Sshow_com"] = 0;
	$doc->updateUserShowComment($_SESSION["Sid_user"], 0);
}

$title = _l("Document Manager");

require_once ("head.php");

?>
<p style="display: inline"><br /></p>
<h1><?php echo $title; ?></h1>
<?php if (!empty($error)) { echo "<p class=\"error\">" . $error . "</p>"; } ?>
<table style="width: 85%" cellpadding="1" cellspacing="0" class="center">
	<tr>
		<td style="width: 30px">&nbsp;</td>
		<td><img class="vmiddle noborder" src="<?php echo $pngPath; ?>folder.png" alt="Back to the Document Manager" />&nbsp;<a href="browser.php?dir=<?php echo $dir; ?>"><?php __l("Cancel and go back to the Document Manager") ?></a></td>
		<td style="width: 30px">&nbsp;</td>
		<td><img class="vmiddle noborder" src="<?php echo $pngPath; ?>comment<?php echo (!empty($_SESSION["Sshow_com"]) ? "hide" : ""); ?>.png" alt="" />&nbsp;<a href="search.php?dir=<?php echo $dir; ?>&amp;action=search&amp;pattern=<?php echo $pattern; ?>&amp;sort=<?php echo $sort; ?>&amp;searchInFolder=<?php echo $searchInFolder; ?>&amp;searchInFile=<?php echo $searchInFile; ?>&amp;comment=<?php echo (!empty($_SESSION["Sshow_com"]) ? "2\">" . _l("Hide comments") : "1\">" . _l("Show comments")); ?></a></td>
<?php if ($doc->config["conf_showhelpbutton"]) { ?>
		<td style="width: 30px">&nbsp;</td>
		<td><img class="vmiddle noborder" src="<?php echo $pngPath; ?>help.png" alt="" />&nbsp;<a href="javascript:help();"><?php __l("Help") ?></a></td>
<?php } ?>
		<td style="width: 30px">&nbsp;</td>
		<td><img class="vmiddle noborder" src="<?php echo $pngPath; ?>exit.png" alt="" />&nbsp;<a href="logout.php"><?php __l("Disconnect") ?></a></td>
	</tr>
</table>

<p style="display: inline"><br /></p>

<table style="width: 85%" cellpadding="0" cellspacing="0" class="center">
<!-- En tete de la liste des fichiers -->
	<tr>
		<th>&nbsp;</th>
		<th><a href="search.php?dir=<?php echo $dir; ?>&amp;action=search&amp;pattern=<?php echo $pattern; ?>&amp;sort=<?php echo (!$sort ? 1 : 0); ?>"><?php __l("File Name") ?></a><?php echo (!$sort || $sort == 1 ? "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "sort" . ($sort ? 1 : 2) . ".png\" alt=\"(Tri)\" />" : ""); ?></th>
		<th><a href="search.php?dir=<?php echo $dir; ?>&amp;action=search&amp;pattern=<?php echo $pattern; ?>&amp;sort=<?php echo ($sort == 2 ? "3" : "2"); ?>"><?php __l("Size") ?></a><?php echo ($sort == 2 || $sort == 3 ? "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "sort" . ($sort - 1) . ".png\" alt=\"(Tri)\" />" : ""); ?></th>
		<th>Type</th>
		<th><a href="search.php?dir=<?php echo $dir; ?>&amp;action=search&amp;pattern=<?php echo $pattern; ?>&amp;sort=<?php echo ($sort == 4 ? "5" : "4"); ?>"><?php __l("Last modification") ?></a><?php echo ($sort == 4 || $sort == 5 ? "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "sort" . ($sort - 3) . ".png\" alt=\"(Tri)\" />" : ""); ?></th>
		<th><?php __l("Actions") ?></th>
	</tr>

<!-- Liste des fichiers -->

<?php

if ($searchInFolder)
{
	$listFolders = $doc->searchFolders($pattern);
	$nbFolders = count($listFolders);
}

if ($searchInFile)
{
	$listFiles = $doc->searchFiles($pattern);
	$nbFiles = count($listFiles);
}

$totalFolders = 0;
$totalFiles = 0;

$foldersName = array();

for ($i = 0; $i < $nbFolders; $i++)
{
	if ($doc->hasRight($_SESSION["Sid_user"], "", $listFolders[$i]["id_folder"]))
	{
		$folderPath = $listFolders[$i]["folder_path"];

		if (substr($folderPath, 0, 1) == SEP)
			$folderPath = substr($folderPath, 1);
		if (substr($folderPath, -1) == SEP)
			$folderPath = substr($folderPath, 0, -1);

		$folderPathArray = explode(SEP, $folderPath);
		$folderRealPath = SEP;

		foreach ($folderPathArray as $theFolder)
		{
			if ($theFolder == $listFolders[$i]["id_folder"])
				continue;

			if (!isset($foldersName[$listFolders[$i]["id_folder"]]))
			{
				$q = "SELECT folder_name FROM " . TABLE_PREFIX . "folders WHERE id_folder = '" . $theFolder . "'";
				$folderName = queryOneField($q);
				$foldersName[$theFolder] = $folderName;
			}

			$folderRealPath .= $foldersName[$theFolder] . SEP;
		}

		$doc->totalSize += $listFolders[$i]["folder_size"];
		$totalFolders++;
?>
	<tr class="rowhover">
		<td style="width: 20px; height: 20px"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>folder.png" alt="" /></td>
		<td class="colhover"><a href="browser.php?dir=<?php echo $listFolders[$i]["id_folder"]; ?>&amp;sort=<?php echo $sort; ?>"><?php echo $listFolders[$i]["folder_name"]; ?></a></td>
		<td class="colhover"><?php echo $doc->formatSize($listFolders[$i]["folder_size"]); ?></td>
		<td class="colhover"><?php __l("Folder"); ?></td>
		<td class="colhover"><?php echo dateTimeMy2fr($listFolders[$i]["folder_mtime"]); ?></td>
		<td>
			<img class="vmiddle noborder" src="<?php echo $pngPath; ?>rien.png" alt="" />
<?php
	// What are the allowed actions for this user ?
	if ($doc->hasRight($_SESSION["Sid_user"], "c", $dir)) /* Change comments */
	{
?>
			<a href="editfoldercomment.php?dir=<?php echo $dir; ?>&amp;folder=<?php echo $listFolders[$i]["id_folder"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>edit.png" alt="<?php __l("Edit Comment"); ?>" /></a>
<?php
	}
	else
		echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";

	if ($doc->hasRight($_SESSION["Sid_user"], "p", $dir)) /* Delete a folder */
	{
?>
			<a href="deletefolder.php?dir=<?php echo $dir; ?>&amp;folder=<?php echo $listFolders[$i]["id_folder"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>delete.png" alt="<?php __l("Delete a folder"); ?>" /></a>
<?php
	}
	else
		echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";

	if ($doc->hasRight($_SESSION["Sid_user"], "t", $dir)) /* Rename a folder */
	{
?>
			<a href="renamefolder.php?dir=<?php echo $dir; ?>&amp;folder=<?php echo $listFolders[$i]["id_folder"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>rename.png" alt="<?php __l("Rename a Folder"); ?>" /></a>
<?php
	}
	else
		echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";
?>
			<a href="movefolder.php?dir=<?php echo $dir; ?>&amp;folder=<?php echo $listFolders[$i]["id_folder"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>move.png" alt="<?php __l("Move a document"); ?>" /></a>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td class="comments" colspan="5"><?php echo $folderRealPath; ?></td>
<?php
	if (!empty($_SESSION["Sshow_com"]) && !empty($listFolders[$i]["folder_comment"]))
	{
?>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td class="comments" colspan="5"><?php echo nl2br(trim($listFolders[$i]["folder_comment"])); ?></td>
<?php } ?>
	</tr>
<?php
	}
}

for ($i = 0; $i < $nbFiles; $i++)
{

?>
	<tr class="rowhover">
<?php
	if ($doc->hasRight($_SESSION["Sid_user"], "r", $listFiles[$i]["id_folder"])) /* Read documents */
	{
		$infoFolder = $doc->getFolderInfo($listFiles[$i]["id_folder"]);
		$folderPath = $infoFolder["folder_path"];

		if (substr($folderPath, 0, 1) == SEP)
			$folderPath = substr($folderPath, 1);
		if (substr($folderPath, -1) == SEP)
			$folderPath = substr($folderPath, 0, -1);

		$folderPathArray = explode(SEP, $folderPath);
		$folderRealPath = SEP;

		foreach ($folderPathArray as $theFolder)
		{
			if (!isset($foldersName[$listFiles[$i]["id_folder"]]))
			{
				$q = "SELECT folder_name FROM " . TABLE_PREFIX . "folders WHERE id_folder = '" . $theFolder . "'";
				$folderName = queryOneField($q);
				$foldersName[$theFolder] = $folderName;
			}

			$folderRealPath .= $foldersName[$theFolder];
		}

		$doc->totalSize += $listFiles[$i]["file_size"];
		$totalFiles++;
?>
		<td style="width: 20px; height: 20px"><img class="vmiddle" src="<?php echo $pngPath . $doc->icon($listFiles[$i]["file_name"]); ?>.png" alt="" /></td>
		<td class="colhover"><a href="download.php?dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><?php echo $listFiles[$i]["file_name"]; ?></a></td>
		<td class="colhover"><?php echo $doc->formatSize($listFiles[$i]["file_size"]); ?></td>
		<td class="colhover"><?php echo $doc->type($listFiles[$i]["file_name"]); ?></td>
		<td class="colhover"><?php echo dateTimeMy2fr($listFiles[$i]["file_mtime"]); ?></td>
		<td>
<?php 
// What are the allowed actions for this user ?
 ?>
			<a href="download.php?view=1&amp;dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>view.png" alt="<?php __l("View File"); ?>" /></a>
<?php
		if ($doc->hasRight($_SESSION["Sid_user"], "c", $dir)) /* change Comments on documents */
		{
?>
			<a href="editcomment.php?dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>edit.png" alt="<?php __l("Edit Comment"); ?>" /></a>
<?php
		}
		else
			echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";

		if ($doc->hasRight($_SESSION["Sid_user"], "d", $dir)) /* Delete a documents */
		{
?>
			<a href="deletefile.php?dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>delete.png" alt="<?php __l("Delete a document"); ?>" /></a>
<?php
		}
		else
			echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";

		if ($doc->hasRight($_SESSION["Sid_user"], "n", $dir)) /* Rename a document */
		{
?>
			<a href="rename.php?dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>rename.png" alt="<?php __l("Rename a document"); ?>" /></a>
<?php
		}
		else
			echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";

		if ($doc->hasRight($_SESSION["Sid_user"], "m", $dir)) /* Move a document accross folders */
		{
?>
			<a href="movefile.php?dir=<?php echo $listFiles[$i]["id_folder"]; ?>&amp;file=<?php echo $listFiles[$i]["id_file"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>move.png" alt="<?php __l("Move a document"); ?>" /></a>
<?php
		}
		else
			echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "rien.png\" alt=\"\" />&nbsp;";
?>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td class="comments" colspan="5"><?php echo _l("Folder").": <a href=\"browser.php?dir=".$listFiles[$i]["id_folder"]."\">".$folderRealPath."</a>"; ?></td>
<?php
		if (!empty($_SESSION["Sshow_com"]) && !empty($listFiles[$i]["file_comment"]))
		{
?>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td colspan="5"><?php echo nl2br(trim($listFiles[$i]["file_comment"])); ?></td>
<?php
		}
	}
?>
	</tr>
<?php

}

?>
	<tr>
		<td colspan="6"><hr /></td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
		<td><?php echo $doc->formatSize($doc->totalSize); ?></td>
		<td colspan="2"><?php printf(_l("%s Files and %s Folders"), $totalFiles, 0); ?></td>
		<td>&nbsp;</td>
	</tr>
</table>
<p style="display: inline"><br /></p>
<form method="get" action="search.php">
<div>
<input type="hidden" name="dir" value="<?php echo $dir; ?>" />
<input type="hidden" name="action" value="search" />
<table style="width: 85%" cellpadding="4" cellspacing="0" class="center">
	<tr>
		<th style="width: 20px">&nbsp;</th>
		<th><?php __l("Search :") ?></th>
	</tr>
	<tr>
		<td><img style="vmiddle" src="<?php echo $pngPath; ?>search.png" alt="<?php __l("Search") ?>" /></td>
		<td><input class="int" type="text" name="pattern" size="40" value="<?php echo $pattern; ?>" />&nbsp;&nbsp;<input class="inb" type="submit" value="<?php __l("Search") ?>" /></td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td>
			<input type="checkbox" name="searchInFolder" id="searchInFolder" value="1"<?php if ($searchInFolder) echo " checked=\"checked\""; ?> />&nbsp;<label for="searchInFolder">Dans les dossiers</label><br />
			<input type="checkbox" name="searchInFile" id="searchInFile" value="1"<?php if ($searchInFile) echo " checked=\"checked\""; ?> />&nbsp;<label for="searchInFile">Dans les fichiers</label>
		</td>
	</tr>
</table>
</div>
</form>
<?php require_once ("foot.php"); ?>