<?php
/* *************************************************
 *
 * Document Manager (C) 2002-2010
 * Version 4 - dmanager MySQL
 * Benjamin Sonntag <benjamin@sonntag.fr>
 * Chantal Bernard-Putz <chantal@bernard-putz.net>
 * Franck Denis
 * This software is protected by copyright laws,
 * please read the file COPYRIGHT
 * This software is provided as is with no warranty.
 *
 ************************************************* */


/* $Id: users_rights.php 53 2011-06-14 14:22:05Z benjamin $ */

$admin = 1;

require_once ("common.php");

$fields = array (
	"user"       => array ("request", "integer", 0),
);
getFields($fields);

$title = _l("Users managment");

require_once ("head.php");

?>
<p style="display: inline"><br /></p>
<h1><?php __l("Users Administration") ?></h1>
<?php

if (!empty($error))
	echo "<p class=\"error\">" . $error . "</p>";

$infoUser = $doc->getUser($user);
$listRights = $doc->getRights($user);
$doc->calculRights($user);

if (!is_array($listRights))
	echo "<p class=\"error\">" . $error . "</p>";
else
{

?>
<h2 class="center"><?php printf(_l("Rights for user %s"), $infoUser["user_name"]); ?></h2>
<div id="listRights">
<table border="1" cellpadding="4" cellspacing="0" class="center">
	<tr>
		<th rowspan="2"><?php __l("Delete") ?></th>
		<th rowspan="2"><?php __l("Folder") ?></th>
		<th colspan="6" class="center"><?php __l("Documents Rights") ?></th>
		<th colspan="3" class="center"><?php __l("Folder Rights") ?></th>
	</tr>
	<tr>
		<th><?php __l("Read") ?></th>
		<th><?php __l("Upload") ?></th>
		<th><?php __l("Delete") ?></th>
		<th><?php __l("Rename") ?></th>
		<th><?php __l("Comment") ?></th>
		<th><?php __l("Move") ?></th>
		<th><?php __l("Create") ?></th>
		<th><?php __l("Rename") ?></th>
		<th><?php __l("Delete") ?></th>
	</tr>
<?php

	$folders = array();

	foreach ($listRights as $id_folder => $rights)
	{
		$folderPath = $doc->folderPath($id_folder);
		if (empty($folderPath))
			$folderPath = "/";

		$folders[$folderPath] = array ("id_folder" => $id_folder, "rights" => $rights);
	}

	ksort($folders);
	foreach ($folders as $path => $data)
	{
?>
	<tr>
		<td class="center"><a href="users_rightsdel.php?user=<?php echo $user; ?>&amp;folder=<?php echo $data["id_folder"]; ?>"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>delete.png" alt="<?php __l("Delete"); ?>" /></a></td>
		<td><?php echo $path; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "r") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "u") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "d") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "n") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "c") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "m") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "f") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "t") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
		<td class="center"><?php if (strpos($data["rights"], "p") !== false) echo "<img class=\"vmiddle noborder\" src=\"" . $pngPath . "check.png\" alt=\"\" />"; else echo "&nbsp;"; ?></td>
	</tr>
<?php
	}

echo "</table>\n";
echo "</div>\n";

} // ok.
?>
<p style="display: inline"><br /></p>
<table style="width: 70%" cellpadding="1" cellspacing="0" class="center">
	<tr>
		<td class="center"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>password.png" alt="<?php __l("Add rights to this user") ?>" />&nbsp;<a href="users_rightsadd.php?user=<?php echo $user; ?>"><?php __l("Add rights to this user") ?></a></td>
		<td class="center"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>users.png" alt="<?php __l("User Administration") ?>" />&nbsp;<a href="users_admin.php"><?php __l("User Administration") ?></a></td>
		<td class="center"><img class="vmiddle noborder" src="<?php echo $pngPath; ?>folder.png" alt="<?php __l("Back to the Document Manager") ?>" />&nbsp;<a href="browser.php"><?php __l("Back to the Document Manager") ?></a></td>
	</tr>
</table>
<?php require_once ("foot.php"); ?>